// Client_demo.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"

#include "Client_demo.h"
#include "Client_demoDlg.h"

/* Application context */
struct mdc_context gCtx;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CClient_demoApp

BEGIN_MESSAGE_MAP(CClient_demoApp, CWinApp)
	//{{AFX_MSG_MAP(CClient_demoApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CClient_demoApp construction

CClient_demoApp::CClient_demoApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CClient_demoApp object

CClient_demoApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CClient_demoApp initialization

BOOL CClient_demoApp::InitInstance()
{
	if (!AfxSocketInit())
	{
		AfxMessageBox(IDP_SOCKETS_INIT_FAILED, MB_OK|MB_APPLMODAL|MB_ICONERROR);
		return FALSE;
	}

	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif


	/* redirect stdout to Log.txt file */
	gCtx.LogFile = freopen("Log.txt", "w", stdout);
	if (gCtx.LogFile == NULL)
	{
		AfxMessageBox("Error while redirecting stdout to Log.txt"),
			MB_OK|MB_APPLMODAL|MB_ICONERROR;
		return FALSE;
	}

	strcpy(gCtx.IPaddr, m_lpCmdLine);
	printf("IP address = %s\n",gCtx.IPaddr);
	gCtx.Sock = INVALID_SOCKET;

	gCtx.MaxWidth = gCtx.MaxHeight = 0;

/*	gtMode[K_MODE_STANDBY    ].rq = MD_RQ_STDBY;
	gtMode[K_MODE_Y8         ].rq = MD_RQ_IMG_Y8;
	gtMode[K_MODE_YCRCB422_PK].rq = MD_RQ_IMG_YCRCB422_PK;
	gtMode[K_MODE_YCRCB422_PL].rq = MD_RQ_IMG_YCRCB422_PL;
	gtMode[K_MODE_RAW_RGB_PL ].rq = MD_RQ_IMG_RAW_RGB_PL;
	gtMode[K_MODE_GRAD_H     ].rq = MD_RQ_IMG_GRAD_H;
	gtMode[K_MODE_GRAD_V     ].rq = MD_RQ_IMG_GRAD_V;
	gtMode[K_MODE_EDGE       ].rq = MD_RQ_IMG_EDGE;
	strcpy(gtMode[K_MODE_STANDBY    ].rq_str, "Standby, no image acquisition.");
	strcpy(gtMode[K_MODE_Y8         ].rq_str, "Requesting Y8 image ...");
	strcpy(gtMode[K_MODE_YCRCB422_PK].rq_str, "Requesting packed YCrCb422 image ...");
	strcpy(gtMode[K_MODE_YCRCB422_PL].rq_str, "Requesting planar YCrCb422 image ...");
	strcpy(gtMode[K_MODE_RAW_RGB_PL ].rq_str, "Requesting planar raw RGB image ...");
	strcpy(gtMode[K_MODE_GRAD_H     ].rq_str, "Requesting horizontal Gradient image ...");
	strcpy(gtMode[K_MODE_GRAD_V     ].rq_str, "Requesting vertical Gradient image ...");
	strcpy(gtMode[K_MODE_EDGE       ].rq_str, "Requesting Edge image ...");
	strcpy(gtMode[K_MODE_STANDBY    ].active_str, "");
	strcpy(gtMode[K_MODE_Y8         ].active_str, "Displaying Y8 image ...");
	strcpy(gtMode[K_MODE_YCRCB422_PK].active_str, "Displaying packed YCrCb422 image ...");
	strcpy(gtMode[K_MODE_YCRCB422_PL].active_str, "Displaying planar YCrCb422 image ...");
	strcpy(gtMode[K_MODE_RAW_RGB_PL ].active_str, "Displaying planar raw RGB image ...");
	strcpy(gtMode[K_MODE_GRAD_H     ].active_str, "Displaying horizontal Gradient image computed in %d s");
	strcpy(gtMode[K_MODE_GRAD_V     ].active_str, "Displaying vertical Gradient image computed in %d s");
	strcpy(gtMode[K_MODE_EDGE       ].active_str, "Displaying Edge image computed in %d s");
	gMode = K_MODE_YCRCB422_PL;	// default image format: YCrCb:4:2:2 */

	/* set high priority */
	if ( SetPriorityClass(GetCurrentProcess(), HIGH_PRIORITY_CLASS) == 0)
	{
		AfxMessageBox("Echec appel SetPriorityClass", MB_OK|MB_APPLMODAL|MB_ICONERROR);
		return FALSE;
	}

	// Creation of ThreadComm in charge of communication with mbs270
	gCtx.init_rc = 1;
	gCtx.hThreadComm = ::CreateThread(NULL, 0,
		(LPTHREAD_START_ROUTINE) ThreadComm, (LPVOID) NULL, 0,
		&gCtx.IdThreadComm);
	if (gCtx.hThreadComm == 0)
	{
		AfxMessageBox("Failed creating ThreadComm.", MB_OK|MB_APPLMODAL|MB_ICONERROR);
		return FALSE;
	}
	else
	{
		// attente fin init
		int ii = 5;
		while (ii > 0)
		{
			if (gCtx.init_rc > 0)
			{
				Sleep(1000);
				ii--;
			}
			else
			{
				if (gCtx.init_rc != 0)
				{
					AfxMessageBox("Failed initializing ThreadComm.",
						MB_OK|MB_APPLMODAL|MB_ICONERROR);
					return FALSE;
				}
				ii = 1;
				break;
			}
		}
		if (ii == 0)
		{
			AfxMessageBox("Failed waiting for ThreadComm initialization.",
				MB_OK|MB_APPLMODAL|MB_ICONERROR);
			return FALSE;
		}
	}

	// main window creation:
	CClient_demoDlg dlg;
	m_pMainWnd = &dlg;
	gCtx.hClient_demoDlg = NULL;
	dlg.DoModal();

	if (gCtx.LogFile != NULL) fclose(gCtx.LogFile);
	if (gCtx.Sock != INVALID_SOCKET) closesocket(gCtx.Sock);
	gCtx.Sock = INVALID_SOCKET;

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}
