// Client_demoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Client_demo.h"
#include "Client_demoDlg.h"
#include "RegisterSettingDlg.h"

#define RIGHT_ITEM_LIST {IDC_STATIC_DEMO, \
						 IDC_COMBO_MODE, \
						 IDC_STATIC_RESOLUTION, \
						 IDC_COMBO_RES, \
						 IDC_BUTTON_REGISTER_SETTING, \
						 IDFERMER}

#define BOTTOM_ITEM_LIST {IDC_STATIC_MESSAGE, \
						 IDC_STATIC_SENSOR, \
						 IDFERMER}

typedef struct mode_data {
	md_fmt_t	fmt;
	mcd_rq_t	rq;
	char		rq_str[K_LG_MESSAGE];
	char		active_str[K_LG_MESSAGE];
	char		combo_str[32];
} mode_data_t;

mode_data_t ModeData[] = {
	{MD_FMT_Y8     , MD_RQ_IMG_Y8     , "Requesting Y8 image ..."           , "Displaying Y8 image ..."           , "Y8"     },
	{MD_FMT_YUV422P, MD_RQ_IMG_YUV422P, "Requesting planar YUV422 image ...", "Displaying planar YUV422 image ...", "YUV422P"},
	{MD_FMT_YUYV   , MD_RQ_IMG_YUYV   , "Requesting packed YUYV image ..."  , "Displaying packed YUYV image ..."  , "YUYV"   },
	{MD_FMT_GRB422P, MD_RQ_IMG_GRB422P, "Requesting planar GRB422 image ...", "Displaying planar GRB422 image ...", "GRB422P"},
	{MD_FMT_GRGB   , MD_RQ_IMG_GRGB   , "Requesting packed GRGB image ..."  , "Displaying packed GRGB image ..."  , "GRGB"   },
	{MD_FMT_BAYER8 , MD_RQ_IMG_BAYER  , "Requesting Bayer image ..."        , "Displaying Bayer image ..."        , "BAYER"  },
	{MD_FMT_HGRAD  , MD_RQ_IMG_HGRAD  , "Requesting horizontal gradient image ...", "Displaying horizontal gradient image computed in %d s", "H Gradient"},
	{MD_FMT_VGRAD  , MD_RQ_IMG_VGRAD  , "Requesting vertical gradient image ...", "Displaying vertical gradient image computed in %d s", "V Gradient"},
	{MD_FMT_EDGE   , MD_RQ_IMG_EDGE   , "Requesting edge image ..."         , "Displaying edge image computed in %d s", "Edge"},
};

typedef struct res_data {
	md_res_t	res;
	mcd_rq_t	rq;
	char		combo_str[32];
	int			width, height;
} res_data_t;

res_data_t ResData[] = {
	{MD_RES_QVGA , MD_RQ_RES_QVGA , "QVGA" , 320, 240},
	{MD_RES_VGA  , MD_RQ_RES_VGA  , "VGA"  , 640, 480},
	{MD_RES_QWVGA, MD_RQ_RES_QWVGA, "QWVGA", 376, 240},
	{MD_RES_WVGA , MD_RQ_RES_WVGA , "WVGA" , 752, 480}
};

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CClient_demoDlg dialog

CClient_demoDlg::CClient_demoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CClient_demoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CClient_demoDlg)
	m_staticMessage = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CClient_demoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CClient_demoDlg)
	DDX_Control(pDX, IDC_COMBO_RES, m_comboRes);
	DDX_Control(pDX, IDC_COMBO_MODE, m_comboMode);
	DDX_Text(pDX, IDC_STATIC_MESSAGE, m_staticMessage);
	DDV_MaxChars(pDX, m_staticMessage, K_LG_MESSAGE);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CClient_demoDlg, CDialog)
	//{{AFX_MSG_MAP(CClient_demoDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDFERMER, OnFermer)
	ON_CBN_SELCHANGE(IDC_COMBO_MODE, OnSelchangeComboMode)
	ON_BN_CLICKED(IDC_BUTTON_REGISTER_SETTING, OnButtonRegisterSetting)
	ON_WM_ERASEBKGND()
	ON_CBN_SELCHANGE(IDC_COMBO_RES, OnSelchangeComboRes)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CClient_demoDlg message handlers

void CClient_demoDlg::InitModeAttr()
{
	int ii, idx, nb_mode;
	static char rq_stdby_str[] = "Requesting Standby ...";
	static char active_stdby_str[] = "Standby, no image acquisition.";

	// Mode list. First item is always stand-by. Others are sensor specific.
	gCtx.ModeAttr[0].fmt = -1;
	gCtx.ModeAttr[0].rq  = MD_RQ_STDBY;
	gCtx.ModeAttr[0].rq_str = rq_stdby_str;
	gCtx.ModeAttr[0].active_str = active_stdby_str;
	m_comboMode.ResetContent();
	m_comboMode.AddString("Standby");

	gCtx.ModeIdx = 0;
	idx = 1;
	nb_mode = sizeof(ModeData) / sizeof(ModeData[0]);
	for (ii=0; ii<nb_mode; ii++) {
		if (ModeData[ii].fmt & gCtx.InitData.formats) {
			gCtx.ModeAttr[idx].fmt        = ModeData[ii].fmt;
			gCtx.ModeAttr[idx].rq         = ModeData[ii].rq;
			gCtx.ModeAttr[idx].rq_str     = ModeData[ii].rq_str;
			gCtx.ModeAttr[idx].active_str = ModeData[ii].active_str;
			m_comboMode.AddString(ModeData[ii].combo_str);
			if (gCtx.InitData.default_fmt == ModeData[ii].fmt)
				gCtx.ModeIdx = idx;
			idx++;
		}
	}
}

int CClient_demoDlg::InitResAttr()
{
	int ii, idx, nb_res;
	char	res_str[32];

	m_comboRes.ResetContent();

	// Resolution list. Items are sensor specific.
	gCtx.ResIdx = 0;
	idx = 0;
	nb_res = sizeof(ResData) / sizeof(ResData[0]);
	for (ii=0; ii<nb_res; ii++) {
		if (ResData[ii].res & gCtx.InitData.resolutions) {
			gCtx.ResAttr[idx].rq     = ResData[ii].rq;
			gCtx.ResAttr[idx].width  = ResData[ii].width;
			gCtx.ResAttr[idx].height = ResData[ii].height;
			sprintf(res_str, "%s %dx%d", ResData[ii].combo_str,
				ResData[ii].width, ResData[ii].height);
			m_comboRes.AddString(res_str);
			if (gCtx.InitData.default_res == ResData[ii].res)
				gCtx.ResIdx = idx;
			if (ResData[ii].width > gCtx.MaxWidth)
				gCtx.MaxWidth = ResData[ii].width;
			if (ResData[ii].height > gCtx.MaxHeight)
				gCtx.MaxHeight = ResData[ii].height;
			idx++;
		}
	}

	// Allocate image buffer for max resolution
	gCtx.Image = (unsigned char *) malloc(gCtx.MaxWidth * gCtx.MaxHeight * 3);
	if (gCtx.Image == NULL)
		return -1;

	return 0;
}

BOOL CClient_demoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// Process initialization data sent by server
	// ------------------------------------------
	InitModeAttr();
	InitResAttr();
	switch (gCtx.InitData.sensor)
	{
	case MD_SENSOR_OV7720 :
		SetDlgItemText(IDC_STATIC_SENSOR, "Sensor: Omnivision OV7720");
		break;
	case MD_SENSOR_MT9V032M :
		SetDlgItemText(IDC_STATIC_SENSOR, "Sensor: Micron MT9V032 Monochrome");
		break;
	case MD_SENSOR_MT9V032C :
		SetDlgItemText(IDC_STATIC_SENSOR, "Sensor: Micron MT9V032 Color");
		break;
	default :
		SetDlgItemText(IDC_STATIC_SENSOR, "Sensor unknown!");
	}

	// ------------------------------------------------------------------------
	// Initialize Bitmap Info Header
	// ------------------------------------------------------------------------

	// Create bitmap info structures
	m_bmpInfo.bmiHeader.biSize          = sizeof(BITMAPINFOHEADER);
	m_bmpInfo.bmiHeader.biPlanes        = 1;
	m_bmpInfo.bmiHeader.biBitCount      = 24;
	m_bmpInfo.bmiHeader.biCompression   = BI_RGB;
	m_bmpInfo.bmiHeader.biXPelsPerMeter = 0;
	m_bmpInfo.bmiHeader.biYPelsPerMeter = 0;
	m_bmpInfo.bmiHeader.biClrUsed       = 0;
	m_bmpInfo.bmiHeader.biClrImportant  = 0;
	m_bmpInfo.bmiHeader.biSizeImage     = 0;

	gCtx.hClient_demoDlg = this->m_hWnd;

	// Activate initial settings
	m_comboRes.SetCurSel(gCtx.ResIdx);
	sendSocket((char*) &gCtx.ResAttr[gCtx.ResIdx].rq,
			sizeof(gCtx.ResAttr[gCtx.ResIdx].rq));
	m_bmpInfo.bmiHeader.biWidth  = gCtx.ResAttr[gCtx.ResIdx].width;
	m_bmpInfo.bmiHeader.biHeight = -gCtx.ResAttr[gCtx.ResIdx].height;

	// can not resize here
	m_needResize = 1;

	m_comboMode.SetCurSel(gCtx.ModeIdx);
	OnSelchangeComboMode();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CClient_demoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CClient_demoDlg::OnPaint() 
{
	CPaintDC dc(this); // device context for painting

	if (m_needResize)
	{
		Resize();
		m_needResize = 0;
	}

	if (IsIconic())
	{

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		// Image display
		SetDIBitsToDevice(
			dc.GetSafeHdc(),
			10,	// x-coordinate of upper-left corner of dest. rect
			10,	// y-coordinate of upper-left corner of dest. rect
			m_bmpInfo.bmiHeader.biWidth,	// source rectangle width 
			-m_bmpInfo.bmiHeader.biHeight,	// source rectangle height 
			0,	// x-coordinate of lower-left corner of source rect
			0,	// y-coordinate of lower-left corner of source rect
			0,	// first scan line in array 
			-m_bmpInfo.bmiHeader.biHeight,	// number of scan lines 
			(void*) gCtx.Image,		// address of array with DIB bits
			&m_bmpInfo,			// address of structure with bitmap info
			DIB_RGB_COLORS);			// RGB or palette indices 
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CClient_demoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CClient_demoDlg::OnFermer() 
{
	CDialog::OnOK();
}

void CClient_demoDlg::OnSelchangeComboMode() 
{
	gCtx.ModeIdx = m_comboMode.GetCurSel();
	SetDlgItemText(IDC_STATIC_MESSAGE, gCtx.ModeAttr[gCtx.ModeIdx].rq_str);
	printf("gCtx.ModeIdx = %d\n", gCtx.ModeIdx);
	sendSocket((char*) &gCtx.ModeAttr[gCtx.ModeIdx].rq,
			sizeof(gCtx.ModeAttr[gCtx.ModeIdx].rq));
}

void CClient_demoDlg::OnSelchangeComboRes() 
{
	int NewResIdx, HShift, VShift, HExp, VExp;
	WINDOWPLACEMENT wndpl;
	
	// Resize window
	NewResIdx = m_comboRes.GetCurSel();
	HShift = gCtx.ResAttr[NewResIdx].width  - gCtx.ResAttr[gCtx.ResIdx].width ;
	VShift = gCtx.ResAttr[NewResIdx].height - gCtx.ResAttr[gCtx.ResIdx].height;
	HExp = HShift / 2;
	VExp = VShift / 2;
	GetWindowPlacement(&wndpl);
	wndpl.rcNormalPosition.left   -= HExp;
	wndpl.rcNormalPosition.top    -= VExp;
	wndpl.rcNormalPosition.right  += HExp;
	wndpl.rcNormalPosition.bottom += VExp;
	SetWindowPlacement(&wndpl);

	// Move controls
	int ii;
	int right_items[]  = RIGHT_ITEM_LIST;
	int bottom_items[] = BOTTOM_ITEM_LIST;
	for (ii=0; ii<sizeof(right_items)/sizeof(right_items[0]); ii++)
	{
		GetDlgItem(right_items[ii])->GetWindowPlacement(&wndpl);
		wndpl.rcNormalPosition.left  += HShift;
		wndpl.rcNormalPosition.right += HShift;
		GetDlgItem(right_items[ii])->SetWindowPlacement(&wndpl);
	}
	for (ii=0; ii<sizeof(bottom_items)/sizeof(bottom_items[0]); ii++)
	{
		GetDlgItem(bottom_items[ii])->GetWindowPlacement(&wndpl);
		wndpl.rcNormalPosition.top    += VShift;
		wndpl.rcNormalPosition.bottom += VShift;
		GetDlgItem(bottom_items[ii])->SetWindowPlacement(&wndpl);
	}

	// Send resolution change request
	sendSocket((char*) &gCtx.ResAttr[NewResIdx].rq,
			sizeof(gCtx.ResAttr[NewResIdx].rq));

	// Update m_bmpInfo member
	m_bmpInfo.bmiHeader.biWidth  = gCtx.ResAttr[NewResIdx].width;
	m_bmpInfo.bmiHeader.biHeight = -gCtx.ResAttr[NewResIdx].height;

	gCtx.ResIdx = NewResIdx;

	Invalidate();
	UpdateWindow();
}

void CClient_demoDlg::OnButtonRegisterSetting() 
{
	CRegisterSettingDlg dlg;
	dlg.DoModal();
}

void CClient_demoDlg::Resize()
{
	// Redimension controls depending of image resolution
	// control width is 1.5*resource width
	// control height is 1.625*resource height
	int rightColumnX, rightColumnW;
	int bottomLineX, bottomLineY, bottomLine1Y, bottomLine2Y, bottomLineH, bottomSpaceH;
	int demoDlgW, demoDlgH, initW, initH, HExp, VExp, HShift, VShift;
	WINDOWPLACEMENT wndpl;

	rightColumnX = 10 + gCtx.ResAttr[gCtx.ResIdx].width + 10;
	rightColumnW = 115;
	demoDlgW = rightColumnX + rightColumnW + 15;

	bottomLineX  = 10;
	bottomLineH  = 15;
	bottomSpaceH = 5;
	bottomLine1Y = 10 + gCtx.ResAttr[gCtx.ResIdx].height + 10;
	bottomLine2Y = bottomLine1Y + bottomLineH + bottomSpaceH;
	bottomLineY  = bottomLine2Y + bottomLineH;
	demoDlgH = bottomLineY + 10 + 25;

	GetWindowPlacement(&wndpl);
	initW = wndpl.rcNormalPosition.right - wndpl.rcNormalPosition.left;
	HExp = (demoDlgW - initW) / 2;
	wndpl.rcNormalPosition.left  -= HExp;
	wndpl.rcNormalPosition.right += HExp;
	initH = wndpl.rcNormalPosition.bottom - wndpl.rcNormalPosition.top;
	VExp = (demoDlgH - initH) / 2;
	wndpl.rcNormalPosition.bottom += VExp;
	wndpl.rcNormalPosition.top    -= VExp;
	SetWindowPlacement(&wndpl);

	// Right column items
	GetDlgItem(IDC_STATIC_DEMO)->GetWindowPlacement(&wndpl);
	wndpl.rcNormalPosition.left   = rightColumnX;
	wndpl.rcNormalPosition.right  = rightColumnX + rightColumnW;
	wndpl.rcNormalPosition.top    = 10;
	wndpl.rcNormalPosition.bottom = wndpl.rcNormalPosition.top + 15;
	GetDlgItem(IDC_STATIC_DEMO)->SetWindowPlacement(&wndpl);

	GetDlgItem(IDC_COMBO_MODE)->GetWindowPlacement(&wndpl);
	wndpl.rcNormalPosition.left   = rightColumnX;
	wndpl.rcNormalPosition.right  = rightColumnX + rightColumnW;
	wndpl.rcNormalPosition.top    = 25;
	wndpl.rcNormalPosition.bottom = wndpl.rcNormalPosition.top + 20;
	GetDlgItem(IDC_COMBO_MODE)->SetWindowPlacement(&wndpl);

	GetDlgItem(IDC_STATIC_RESOLUTION)->GetWindowPlacement(&wndpl);
	wndpl.rcNormalPosition.left   = rightColumnX;
	wndpl.rcNormalPosition.right  = rightColumnX + rightColumnW;
	wndpl.rcNormalPosition.top    = 60;
	wndpl.rcNormalPosition.bottom = wndpl.rcNormalPosition.top + 15;
	GetDlgItem(IDC_STATIC_RESOLUTION)->SetWindowPlacement(&wndpl);

	GetDlgItem(IDC_COMBO_RES)->GetWindowPlacement(&wndpl);
	wndpl.rcNormalPosition.left   = rightColumnX;
	wndpl.rcNormalPosition.right  = rightColumnX + rightColumnW;
	wndpl.rcNormalPosition.top    = 75;
	wndpl.rcNormalPosition.bottom = wndpl.rcNormalPosition.top + 20;
	GetDlgItem(IDC_COMBO_RES)->SetWindowPlacement(&wndpl);

	GetDlgItem(IDC_BUTTON_REGISTER_SETTING)->GetWindowPlacement(&wndpl);
	wndpl.rcNormalPosition.left   = rightColumnX;
	wndpl.rcNormalPosition.right  = rightColumnX + rightColumnW;
	wndpl.rcNormalPosition.top    = 110;
	wndpl.rcNormalPosition.bottom = wndpl.rcNormalPosition.top + 20;
	GetDlgItem(IDC_BUTTON_REGISTER_SETTING)->SetWindowPlacement(&wndpl);

	// bottom lines
	GetDlgItem(IDC_STATIC_SENSOR)->GetWindowPlacement(&wndpl);
	wndpl.rcNormalPosition.left   = bottomLineX;
	wndpl.rcNormalPosition.right  = bottomLineX + 240;
	wndpl.rcNormalPosition.top    = bottomLine1Y;
	wndpl.rcNormalPosition.bottom = bottomLine1Y + bottomLineH;
	GetDlgItem(IDC_STATIC_SENSOR)->SetWindowPlacement(&wndpl);

	GetDlgItem(IDC_STATIC_MESSAGE)->GetWindowPlacement(&wndpl);
	wndpl.rcNormalPosition.left   = bottomLineX;
	wndpl.rcNormalPosition.right  = bottomLineX + 240;
	wndpl.rcNormalPosition.top    = bottomLine2Y;
	wndpl.rcNormalPosition.bottom = bottomLine2Y + bottomLineH;
	GetDlgItem(IDC_STATIC_MESSAGE)->SetWindowPlacement(&wndpl);

	GetDlgItem(IDFERMER)->GetWindowPlacement(&wndpl);
	wndpl.rcNormalPosition.right  = rightColumnX + rightColumnW;
	wndpl.rcNormalPosition.left   = wndpl.rcNormalPosition.right - 60;
	wndpl.rcNormalPosition.bottom = bottomLineY;
	wndpl.rcNormalPosition.top    = wndpl.rcNormalPosition.bottom - 20;
	GetDlgItem(IDFERMER)->SetWindowPlacement(&wndpl);
}
