/****************************************************************************
*                                                                           *
*                      General.h : dclarations gnrales                   *
*                                                                           *
*****************************************************************************
*   SUIVI DES MODIFICATIONS                                                 *
*                                                                           *
*                                                                           *
****************************************************************************/
#ifndef GENERAL_H
#define GENERAL_H

#ifndef STRICT
#define STRICT	/* pour compatibilit projets MFC et bibliothques standard */
#endif

#include <stdio.h>
#include <Windows.h>
#include <Winbase.h>



/* constantes gnrales */
/* -------------------- */
#define K_PI			3.1415926535897932384626433832795
#define	K_VRAI			1
#define	K_FAUX			0
#define K_OK			1
#define K_NOK			0
#define K_PASFICHIER	0
#define K_NOUVEAU		1
#define K_AJOUT			2
#define K_FIN			0
#define K_DEBUT			1
#define K_ARRET			2

/* Macros */
/* ------ */
#define M_TRACE_ERR(StrErr) GETraceErr(__FILE__, __LINE__, StrErr)
#define M_ABS(a)	(((a) >= 0) ? (a) : (-(a))) 
#define M_MIN(a,b)  (((a) < (b)) ? (a) : (b)) 
#define M_MAX(a,b)  (((a) < (b)) ? (b) : (a)) 


/* structures */
/* --------- */
typedef struct S_POL	/* coordonnes polaires en m et rad */
{
	double r,a;
} S_POL;

typedef struct S_XY		/* coordonnes physiques en m */
{
	double X,Y;
} S_XY;

typedef struct S_POSE
{
	S_XY	xy;
	double Theta;		/* orientation en radian */
} S_POSE;

// macro de copie d'un lment de type S_POSE, entres de type S_POSE
#define M_COPY_POSE(qDest,qSrc) \
	qDest.xy.X = qSrc.xy.X; \
	qDest.xy.Y = qSrc.xy.Y; \
	qDest.Theta = qSrc.Theta;


#endif	/* toujours  la fin du fichier */