#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <fcntl.h>
#include <linux/ioctl.h>
#include <linux/ucb1400_adc.h>

#define NB_READ 1000
#define ADC_DEV_NAME "/dev/ucb1400-adc"

int main(int argc, char *argv[])
{
  int adc_dev, ii;
  struct misc_adc adc_data;
  struct timeval tvs, tve, dtv;

  printf("\n\n   ***   test_adc_speed   ***\n\n");
  printf("Speed test for UCB1400 ADC driver\n\n");

  adc_dev = open(ADC_DEV_NAME, O_RDWR);
  if (adc_dev < 0) {
    printf("%s ", ADC_DEV_NAME);
    perror("open failed");
    exit(1);
  }
  else {
    printf("%s open succeeded.\n", ADC_DEV_NAME);
    if (argc == 1)
	    adc_data.channel_count = 4;
    else {
	    adc_data.channel_count = atoi(argv[1]);
	    if (adc_data.channel_count > UCB1400_NB_ADC_CHANNEL)
		    goto adc_close;
    }
    for (ii=0; ii<adc_data.channel_count; ii++)
	    adc_data.channel[ii].number = ii;
    gettimeofday(&tvs, NULL);
    for (ii=0; ii<NB_READ; ii++) {
      if (ioctl(adc_dev, MISCIOCADC, (void*) &adc_data) < 0) {
	perror("ioctl ADC");
	break;
      }
    }
    gettimeofday(&tve, NULL);
    timersub(&tve, &tvs, &dtv);
    printf("%d conversions for %d channels in %ld.%06d seconds.\n",
	   NB_READ, adc_data.channel_count,dtv.tv_sec, dtv.tv_usec );

    adc_close:
    close(adc_dev);
  }
}
