 
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>

#include "ippdefs.h"
#include "ippIP.h"


void print_buf(Ipp8u* buf)
{
  printf("srcBuf:\n");
  printf("%d %d %d\n", buf[0], buf[1], buf[2]);
  printf("%d %d %d\n", buf[3], buf[4], buf[5]);
  printf("%d %d %d\n", buf[6], buf[7], buf[8]);
}

void print_kernel(Ipp32s* kernel)
{
  printf("kernel:\n");
  printf("%d %d %d\n", kernel[0], kernel[1], kernel[2]);
  printf("%d %d %d\n", kernel[3], kernel[4], kernel[5]);
  printf("%d %d %d\n", kernel[6], kernel[7], kernel[8]);
}

void test_filter(Ipp32s *kernel)
{
  IppStatus status;
  Ipp8u srcBuf[9] = {0,1,2,3,4,5,6,7,8};
  Ipp8u dstBuf[1];
  IppiSize roiSize = {1,1};
  IppiSize kernelSize = {3,3};
  IppiPoint kernelAnchor = {1,1};

  print_buf(srcBuf);
  print_kernel(kernel);
  status = ippiFilter_8u_C1R(srcBuf+4,
			     3,
			     dstBuf,
			     1,
			     roiSize,
			     kernel,
			     kernelSize,
			     kernelAnchor,
			     1);
  if (status != ippStsNoErr)
    printf("ippiFilter_8u_C1R ERROR, status = %d\n", status);
  else
    printf("dstBuf = %d\n\n", (int) dstBuf[0]);
}

void test1(Ipp32s *kernel)
{
  printf("test1: shows match between pixels and kernel coefficients\n");
  memset(kernel, 0, sizeof(Ipp32s)*9); kernel[0] = 1;
  test_filter(kernel);
  memset(kernel, 0, sizeof(Ipp32s)*9); kernel[1] = 1;
  test_filter(kernel);
  memset(kernel, 0, sizeof(Ipp32s)*9); kernel[2] = 1;
  test_filter(kernel);
  memset(kernel, 0, sizeof(Ipp32s)*9); kernel[3] = 1;
  test_filter(kernel);
  memset(kernel, 0, sizeof(Ipp32s)*9); kernel[4] = 1;
  test_filter(kernel);
  memset(kernel, 0, sizeof(Ipp32s)*9); kernel[5] = 1;
  test_filter(kernel);
  memset(kernel, 0, sizeof(Ipp32s)*9); kernel[6] = 1;
  test_filter(kernel);
  memset(kernel, 0, sizeof(Ipp32s)*9); kernel[7] = 1;
  test_filter(kernel);
  memset(kernel, 0, sizeof(Ipp32s)*9); kernel[8] = 1;
  test_filter(kernel);
  memset(kernel, 0, sizeof(Ipp32s)*9); kernel[0] = -1;
  test_filter(kernel);
  printf("   !!!   does not accept negative results   !!!\n");
  printf("Press return key to continue...\n");
  fflush(stdin); getchar();
}

void test2(Ipp32s *kernel)
{
  printf("test2: shows saturation of result\n");
  int ii;
  for (ii=0;ii<9;ii++) kernel[ii] = 1;
  test_filter(kernel);
  for (ii=0;ii<9;ii++) kernel[ii] = 2;
  test_filter(kernel);
  for (ii=0;ii<9;ii++) kernel[ii] = 3;
  test_filter(kernel);
  for (ii=0;ii<9;ii++) kernel[ii] = 4;
  test_filter(kernel);
  for (ii=0;ii<9;ii++) kernel[ii] = 5;
  test_filter(kernel);
  for (ii=0;ii<9;ii++) kernel[ii] = 6;
  test_filter(kernel);
  for (ii=0;ii<9;ii++) kernel[ii] = 7;
  test_filter(kernel);
  for (ii=0;ii<9;ii++) kernel[ii] = 8;
  test_filter(kernel);
  printf("   !!!   saturation   !!!\n");
  for (ii=0;ii<9;ii++) kernel[ii] = 10;
  test_filter(kernel);
  printf("   !!!   saturation   !!!\n");
  printf("Press return key to continue...\n");
  fflush(stdin); getchar();
}

int main(int argc, char** argv)
{
  Ipp32s kernel[9];

  test1(kernel);

  test2(kernel);

  exit(0);
}
